
import java.util.HashMap;
import java.util.Map;

public class BookmarkCollection extends NodeWithChildren {
  protected String baseUrl;
  protected Map    idmap;

  public BookmarkCollection(String baseUrl) {
    super(null, null);
    this.baseUrl = baseUrl;
    idmap = new HashMap();
  }

  public String getBaseUrl() {
    return baseUrl;
  }

  public void setBaseUrl(String baseUrl) {
    this.baseUrl = baseUrl;
  }

  public void registerNode(NodeWithTitle node) {
    idmap.put(node.getId(), node);
  }

  public void unregisterNode(NodeWithTitle node) {
    idmap.remove(node.getId());
  }

  public NodeWithTitle getNodeById(String id) {
    return (NodeWithTitle) idmap.get(id);
  }
  
}
