import string

ELEMENT_NODE                = 1
ATTRIBUTE_NODE              = 2
TEXT_NODE                   = 3
CDATA_SECTION_NODE          = 4
ENTITY_REFERENCE_NODE       = 5
ENTITY_NODE                 = 6
PROCESSING_INSTRUCTION_NODE = 7
COMMENT_NODE                = 8
DOCUMENT_NODE               = 9
DOCUMENT_TYPE_NODE          = 10
DOCUMENT_FRAGMENT_NODE      = 11
NOTATION_NODE               = 12


def find_first_child(parent, type, name):
    for child in parent._get_childNodes():
        if child._get_nodeType() == type and \
           child._get_nodeName() == name:
            return child

def find_first_elem(parent, name):
    for child in parent._get_childNodes():
        if child._get_nodeType() == ELEMENT_NODE and \
           child._get_nodeName() == name:
            return child

def data(parent, alternative = None):
    if parent == None: return alternative
    
    content = []
    for child in parent._get_childNodes():
        if child._get_nodeType() == TEXT_NODE or \
           child._get_nodeType() == CDATA_SECTION_NODE:
            content.append(child._get_nodeValue())

    return string.join(content, "")

def recursive_data(parent, alternative = None):
    if parent == None: return alternative
    
    content = []
    for child in parent._get_childNodes():
        type = child._get_nodeType()
        if type == TEXT_NODE or type == CDATA_SECTION_NODE:
            content.append(child._get_nodeValue())
        elif type == ELEMENT_NODE:
            content.append(recursive_data(child))

    return string.join(content, "")

def predicate(nodetype, nodename):
    return lambda node, type = nodetype, name = nodename: \
                               (node._get_nodeType() == type and
                                node._get_nodeName() == name)

def type_predicate(nodetype):
    return lambda node, type = nodetype: node._get_nodeType() == type
    
