class NamespaceNodeFilter:

    FILTER_ACCEPT  = 1
    FILTER_SKIP    = 3
    
    ELEMENT_NODE   = 1
    ATTRIBUTE_NODE = 2

    def __init__(self, namespaces = []):
        self._namespaces = {}
        for namespace in namespaces:
            self._namespaces[namespace] = 1
    
    def acceptNode(self, node):
        if (node.nodeType != NamespaceNodeFilter.ELEMENT_NODE and
            node.nodeType != NamespaceNodeFilter.ATTRIBUTE_NODE) or \
            self._namespaces.has_key(node.namespaceURI):
            return FILTER_ACCEPT
        else:
            return FILTER_SKIP    # don't reject children
