import sys, string, codecs
from domutils import *
from xml.dom.ext.reader.Sax2 import Reader

# --- Templates

top = \
"""
<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0 Transitional//EN\">
<HTML>
<HEAD>
  <TITLE>%s</TITLE>
</HEAD>

<BODY>
<H1>%s</H1>
"""

bottom = \
"""        
<HR>

<ADDRESS>
Converted by xbel2html.py, using the DOM.
</ADDRESS>

</BODY>
</HTML>
"""


# --- Conversion functions

def convert_bookmark(bookmark, out):
    title = data(find_first_child(bookmark, ELEMENT_NODE, "title"),
                 "<no title>")
    desc = data(find_first_child(bookmark, ELEMENT_NODE, "desc"), "")
    url = bookmark.getAttribute("href")

    out.write('  <li><a href="%s">%s</a> %s\n' % (url, title, desc))

    
def convert_folder(folder, level, out):
    title = data(find_first_child(folder, ELEMENT_NODE, "title"),
                 "<no title>")
    if level < 4:
        out.write("<h%d>%s</h%d>\n" % (level, title, level))
    else:
        out.write("  <li><b>%s</b>\n"  % title)
    convert_folder_contents(folder, level, out)


def convert_folder_contents(folder, level, out):
    bookmarks = filter(predicate(ELEMENT_NODE, "bookmark"),
                       folder.childNodes)
    folders = filter(predicate(ELEMENT_NODE, "folder"),
                     folder.childNodes)
    
    if len(bookmarks) > 0 or (level >= 3 and len(folders) > 0):
        out.write("<ul>\n")

    for bookmark in bookmarks:
        convert_bookmark(bookmark, out)
        
    if not (level >= 3 and len(folders) > 0) and \
       len(bookmarks) > 0:
        out.write("</ul>\n")

    for folder in folders:
        convert_folder(folder, level + 1, out)

    if level >= 3 and len(folders) > 0:        
        out.write("</ul>\n")        


def convert(doc, out = None):
    out = out or sys.stdout
    
    root = doc.documentElement
    title = data(find_first_child(root, ELEMENT_NODE, "title"),
                 "Bookmarks")
    out.write(top % (title, title))

    desc = find_first_child(root, ELEMENT_NODE, "desc")
    if desc:
        out.write("<p>%s</p>\n" % data(desc))

    convert_folder_contents(root, 0, out)

    out.write(bottom)


outf = codecs.open(sys.argv[2], "w", "iso-8859-1")
convert(Reader().fromStream(open(sys.argv[1])), outf)
