
import sys, re, string
from pprint import pprint

reg_link_start = re.compile("<a\s+", re.IGNORECASE) # start of link
reg_link_url   = re.compile("href\s*=[\"']?([^\"'> ]*)",  # find URL
                            re.IGNORECASE)

def find_links(doc):
    links = {}
    
    pos = 0
    match = reg_link_start.search(doc, pos)
    while match:
        pos = match.end()
        match = reg_link_url.search(doc, pos)
        tagend = string.find(doc, ">", pos)
        if match and match.start() < tagend:            
            link = match.group(1)
            if link:
                links[link] = link
        
        match = reg_link_start.search(doc, pos)

    return links.keys()

if __name__ == "__main__":
    pprint(find_links(open(sys.argv[1]).read()))
