
import sys, codecs
from xml.utils import qp_xml

# --- Templates

top = \
"""
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<HTML>
<HEAD>
  <TITLE>%s</TITLE>
</HEAD>

<BODY>
"""

bottom = \
"""       
<HR>

<ADDRESS>
Converted to HTML by rss2html.py.
</ADDRESS>

</BODY>
</HTML>
"""

# --- Utilities

def find_first_element(parent, name):
    for child in parent.children:
        if child.name == name:
            return child

# --- The converter

def conv2html(root, out = None):
    out = out or sys.stdout
    
    channel = find_first_element(root, "channel")
    title = find_first_element(channel, "title").textof()
    link = find_first_element(channel, "link").textof()
    descr = find_first_element(channel, "description")
    if descr != None:
        descr = descr.textof()
    else:
        descr = None
    
    out.write(top % title)
    out.write('<h1><a href="%s">%s</a></h1>\n' % (link, title))
    if descr:
        out.write('<p>%s</p>\n\n' % descr)

    out.write("<ul>\n")
    for child in root.children + channel.children:
        if child.name == "item":
            convitem(child, out)
    out.write("</ul>\n")

    out.write(bottom)

def convitem(item, out):
    title = find_first_element(item, "title").textof()
    link = find_first_element(item, "link").textof()
    descr = find_first_element(item, "description")
    if descr != None:
        descr = descr.textof()
    else:
        descr = ""

    out.write('  <li><a href="%s">%s</a> %s\n' % (link, title, descr))

# --- Main program

parser = qp_xml.Parser()
outf = codecs.open(sys.argv[2], "w", "iso-8859-1")
doc = parser.parse(open(sys.argv[1]))
conv2html(doc, outf)

