
import sys
from xml.dom import Node
from xml.dom.ext.reader.Sax2 import Reader
from xpathgen import make_xpath_expr

def analyze(node, counts):
    expr = make_xpath_expr(node, 0)
    counts[expr] = counts.get(expr, 0) + 1

    for child in node.childNodes:
        if child.nodeType == Node.ELEMENT_NODE:
            analyze(child, counts)

# === Collect results
        
file = sys.argv[1]

print "===", file
doc = Reader().fromStream(open(file))
counts = {}
analyze(doc, counts)

# === Print report

exprs = counts.keys()
exprs.sort()

for expr in exprs:
    print "%70s  %d" % (expr, counts[expr])
