
import sys
from xml.sax import handler, make_parser

from xml.arch.xmlarch import ArchDocHandler
from xml.sax.saxexts import make_parser
from xml.sax.saxutils import ErrorRaiser, XMLGenerator
from xml.sax.handler import feature_external_pes, feature_namespaces

# --- Templates

top = \
"""
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<HTML>
<HEAD>
  <TITLE>Slashdot news</TITLE>
</HEAD>

<BODY>
<A HREF="http://slashdot.org"><H1>Slashdot news</H1></A>

<p>
News for nerds.
</p>
"""


        
# --- Conversion function

def htmlconv(infile, out):
    outf = open(out, "w")

    arch_handler = ArchDocHandler()
    arch_handler.add_content_handler('rss', RSS2HTMLHandler(outf))
    
    parser = make_parser("xml.sax.drivers2.drv_xmlproc")
    parser.setFeature(feature_external_pes, 1)
    parser.setFeature(feature_namespaces, 0)
    parser.setContentHandler(arch_handler)
    parser.parse(infile)
    
    outf.close()
    
# --- Main program
    
if __name__ == "__main__":
    import sys
    htmlconv(sys.argv[1], sys.argv[2])
