
import string

class SAXHandler2ContentHandler:

    def __init__(self, content_handler, lex_handler = None):
        self._content_handler = content_handler

        # shortcuts
        self.startDocument  = self._content_handler.startDocument
        self.endDocument    = self._content_handler.endDocument
        self.characters     = self._content_handler.characters
        self.startNamespace = self._content_handler.startPrefixMapping
        self.endNamespace   = self._content_handler.endPrefixMapping
        self.processingInstruction = \
                  self._content_handler.processingInstruction

        if lex_handler:
            self.comment = lex_handler.comment

    def startElement(self, name, atts):
        self._content_handler.startElementNS(self.makeName(name), None, atts)

    def endElement(self, name):
        self._content_handler.endElementNS(self.makeName(name), None)

    def comment(self, content):
        pass

    def makeName(self, name):
        pair = string.split(name, "`")
        if len(pair) == 1:
            return (None, name)
        else:
            return tuple(pair)
